'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AdminRoutes = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactRouterDom = require('react-router-dom');

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _getContext = require('recompose/getContext');

var _getContext2 = _interopRequireDefault(_getContext);

var _Loading = require('./mui/layout/Loading');

var _Loading2 = _interopRequireDefault(_Loading);

var _NotFound = require('./mui/layout/NotFound');

var _NotFound2 = _interopRequireDefault(_NotFound);

var _WithPermissions = require('./auth/WithPermissions');

var _WithPermissions2 = _interopRequireDefault(_WithPermissions);

var _types = require('./auth/types');

var _reducer = require('./reducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initialPermissions = '@@ar/initialPermissions';

var AdminRoutes = exports.AdminRoutes = function (_Component) {
    (0, _inherits3.default)(AdminRoutes, _Component);

    function AdminRoutes() {
        var _ref,
            _this2 = this;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, AdminRoutes);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AdminRoutes.__proto__ || Object.getPrototypeOf(AdminRoutes)).call.apply(_ref, [this].concat(args))), _this), _this.state = { childrenToRender: [], permissions: initialPermissions }, _this.getPermissions = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            var authClient, permissions;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            authClient = _this.props.authClient;
                            _context.prev = 1;
                            _context.next = 4;
                            return authClient(_types.AUTH_GET_PERMISSIONS);

                        case 4:
                            permissions = _context.sent;

                            _this.setState({ permissions: permissions });
                            _context.next = 11;
                            break;

                        case 8:
                            _context.prev = 8;
                            _context.t0 = _context['catch'](1);

                            _this.setState({ permissions: initialPermissions });

                        case 11:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this2, [[1, 8]]);
        })), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }
    // Can't use null or undefined here as authClient may return any those values


    (0, _createClass3.default)(AdminRoutes, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (typeof this.props.children === 'function') {
                this.getPermissions();
            } else {
                this.setState({ childrenToRender: this.props.children });
            }
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            var _this3 = this;

            if (!nextProps.isLoggedIn && nextProps.isLoggedIn !== this.props.isLoggedIn) {
                this.setState({ permissions: initialPermissions }, function () {
                    return _this3.getPermissions();
                });
            }

            if (typeof nextProps.children === 'function' && nextState.permissions !== this.state.permissions) {
                var children = nextProps.children;


                var childrenFuncResult = children(nextState.permissions);
                if (childrenFuncResult.then) {
                    childrenFuncResult.then(function (resolvedChildren) {
                        _this3.setState({
                            childrenToRender: resolvedChildren.filter(function (child) {
                                return child;
                            })
                        });
                    });
                    return;
                }

                return this.setState({
                    childrenToRender: childrenFuncResult.filter(function (child) {
                        return child;
                    })
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                customRoutes = _props.customRoutes,
                dashboard = _props.dashboard,
                catchAll = _props.catchAll,
                title = _props.title;
            var childrenToRender = this.state.childrenToRender;


            if (!childrenToRender || childrenToRender.length === 0) {
                return _react2.default.createElement(_reactRouterDom.Route, {
                    path: '/',
                    key: 'loading',
                    render: function render() {
                        return _react2.default.createElement(_Loading2.default, {
                            loadingPrimary: 'ra.page.loading',
                            loadingSecondary: 'ra.message.loading'
                        });
                    }
                });
            }

            return _react2.default.createElement(
                'div',
                null,
                _react.Children.map(childrenToRender, function (child) {
                    return (0, _react.cloneElement)(child, {
                        context: 'registration'
                    });
                }),
                _react2.default.createElement(
                    _reactRouterDom.Switch,
                    null,
                    customRoutes && customRoutes.map(function (route, index) {
                        return _react2.default.createElement(_reactRouterDom.Route, {
                            key: index,
                            exact: route.props.exact,
                            path: route.props.path,
                            component: route.props.component,
                            render: route.props.render,
                            children: route.props.children // eslint-disable-line react/no-children-prop
                        });
                    }),
                    _react.Children.map(childrenToRender, function (child) {
                        return _react2.default.createElement(_reactRouterDom.Route, {
                            path: '/' + child.props.name,
                            render: function render(props) {
                                return (0, _react.cloneElement)(child, (0, _extends3.default)({
                                    context: 'route'
                                }, props));
                            }
                        });
                    }),
                    dashboard ? _react2.default.createElement(_reactRouterDom.Route, {
                        exact: true,
                        path: '/',
                        render: function render(routeProps) {
                            return _react2.default.createElement(_WithPermissions2.default, (0, _extends3.default)({
                                authParams: { route: 'dashboard' }
                            }, routeProps, {
                                render: function render(props) {
                                    return _react2.default.createElement(dashboard, props);
                                }
                            }));
                        }
                    }) : childrenToRender[0] && _react2.default.createElement(_reactRouterDom.Route, {
                        exact: true,
                        path: '/',
                        render: function render() {
                            return _react2.default.createElement(_reactRouterDom.Redirect, {
                                to: '/' + childrenToRender[0].props.name
                            });
                        }
                    }),
                    _react2.default.createElement(_reactRouterDom.Route, {
                        render: function render() {
                            return _react2.default.createElement(catchAll || _NotFound2.default, {
                                title: title
                            });
                        }
                    })
                )
            );
        }
    }]);
    return AdminRoutes;
}(_react.Component);

var componentPropType = _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]);

AdminRoutes.propTypes = {
    authClient: _propTypes2.default.func,
    children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.node]),
    catchAll: componentPropType,
    customRoutes: _propTypes2.default.array,
    isLoggedIn: _propTypes2.default.bool,
    title: _propTypes2.default.string,
    dashboard: componentPropType
};

var mapStateToProps = function mapStateToProps(state) {
    return {
        isLoggedIn: (0, _reducer.isLoggedIn)(state)
    };
};

exports.default = (0, _compose2.default)((0, _getContext2.default)({
    authClient: _propTypes2.default.func
}), (0, _reactRedux.connect)(mapStateToProps, {}))(AdminRoutes);