'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reduxForm = require('redux-form');

var _reactRedux = require('react-redux');

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Card = require('material-ui/Card');

var _Card2 = _interopRequireDefault(_Card);

var _Avatar = require('material-ui/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Progress = require('material-ui/Progress');

var _LockOutline = require('material-ui-icons/LockOutline');

var _LockOutline2 = _interopRequireDefault(_LockOutline);

var _styles = require('material-ui/styles');

var _defaultTheme = require('../defaultTheme');

var _defaultTheme2 = _interopRequireDefault(_defaultTheme);

var _authActions = require('../../actions/authActions');

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

var _Notification = require('../layout/Notification');

var _Notification2 = _interopRequireDefault(_Notification);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
    return {
        main: {
            display: 'flex',
            flexDirection: 'column',
            minHeight: '100vh',
            alignItems: 'center',
            justifyContent: 'flex-start',
            background: 'url(https://source.unsplash.com/random/1600x900)',
            backgroundRepeat: 'no-repeat',
            backgroundSize: 'cover'
        },
        card: {
            minWidth: 300,
            marginTop: '6em'
        },
        avatar: {
            margin: '1em',
            display: 'flex',
            justifyContent: 'center'
        },
        icon: {
            backgroundColor: theme.palette.secondary[500]
        },
        form: {
            padding: '0 1em 1em 1em'
        },
        input: {
            marginTop: '1em'
        },
        button: {
            width: '100%'
        }
    };
};

// see http://redux-form.com/6.4.3/examples/material-ui/
var renderInput = function renderInput(_ref) {
    var _ref$meta = _ref.meta;
    _ref$meta = _ref$meta === undefined ? {} : _ref$meta;
    var touched = _ref$meta.touched,
        error = _ref$meta.error,
        inputProps = (0, _objectWithoutProperties3.default)(_ref.input, []),
        props = (0, _objectWithoutProperties3.default)(_ref, ['meta', 'input']);
    return _react2.default.createElement(_TextField2.default, (0, _extends3.default)({
        error: !!(touched && error),
        helperText: touched && error
    }, inputProps, props, {
        fullWidth: true
    }));
};

var sanitizeRestProps = function sanitizeRestProps(_ref2) {
    var classes = _ref2.classes,
        className = _ref2.className,
        handleSubmit = _ref2.handleSubmit,
        isLoading = _ref2.isLoading,
        translate = _ref2.translate,
        location = _ref2.location,
        title = _ref2.title,
        locale = _ref2.locale,
        array = _ref2.array,
        theme = _ref2.theme,
        rest = (0, _objectWithoutProperties3.default)(_ref2, ['classes', 'className', 'handleSubmit', 'isLoading', 'translate', 'location', 'title', 'locale', 'array', 'theme']);
    return rest;
};

/**
 * A standalone login page, to serve as authentication gate to the admin
 *
 * Expects the user to enter a login and a password, which will be checked
 * by the `authClient` using the AUTH_LOGIN verb. Redirects to the root page
 * (/) upon success, otherwise displays an authentication error message.
 *
 * Copy and adapt this component to implement your own login logic
 * (e.g. to authenticate via email or facebook or anything else).
 *
 * @example
 *     import MyLoginPage from './MyLoginPage';
 *     const App = () => (
 *         <Admin loginPage={MyLoginPage} authClient={authClient}>
 *             ...
 *        </Admin>
 *     );
 */

var Login = function (_Component) {
    (0, _inherits3.default)(Login, _Component);

    function Login() {
        var _ref3;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, Login);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref3 = Login.__proto__ || Object.getPrototypeOf(Login)).call.apply(_ref3, [this].concat(args))), _this), _this.login = function (auth) {
            return _this.props.userLogin(auth, _this.props.location.state ? _this.props.location.state.nextPathname : '/');
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(Login, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                classes = _props.classes,
                className = _props.className,
                handleSubmit = _props.handleSubmit,
                isLoading = _props.isLoading,
                translate = _props.translate,
                rest = (0, _objectWithoutProperties3.default)(_props, ['classes', 'className', 'handleSubmit', 'isLoading', 'translate']);


            return _react2.default.createElement(
                'div',
                (0, _extends3.default)({
                    className: (0, _classnames2.default)(classes.main, className)
                }, sanitizeRestProps(rest)),
                _react2.default.createElement(
                    _Card2.default,
                    { className: classes.card },
                    _react2.default.createElement(
                        'div',
                        { className: classes.avatar },
                        _react2.default.createElement(
                            _Avatar2.default,
                            { className: classes.icon },
                            _react2.default.createElement(_LockOutline2.default, null)
                        )
                    ),
                    _react2.default.createElement(
                        'form',
                        { onSubmit: handleSubmit(this.login) },
                        _react2.default.createElement(
                            'div',
                            { className: classes.form },
                            _react2.default.createElement(
                                'div',
                                { className: classes.input },
                                _react2.default.createElement(_reduxForm.Field, {
                                    name: 'username',
                                    component: renderInput,
                                    label: translate('ra.auth.username'),
                                    disabled: isLoading
                                })
                            ),
                            _react2.default.createElement(
                                'div',
                                { className: classes.input },
                                _react2.default.createElement(_reduxForm.Field, {
                                    name: 'password',
                                    component: renderInput,
                                    label: translate('ra.auth.password'),
                                    type: 'password',
                                    disabled: isLoading
                                })
                            )
                        ),
                        _react2.default.createElement(
                            _Card.CardActions,
                            null,
                            _react2.default.createElement(
                                _Button2.default,
                                {
                                    raised: true,
                                    type: 'submit',
                                    color: 'primary',
                                    disabled: isLoading,
                                    className: classes.button
                                },
                                isLoading && _react2.default.createElement(_Progress.CircularProgress, { size: 25, thickness: 2 }),
                                translate('ra.auth.sign_in')
                            )
                        )
                    )
                ),
                _react2.default.createElement(_Notification2.default, null)
            );
        }
    }]);
    return Login;
}(_react.Component);

Login.propTypes = (0, _extends3.default)({}, _reduxForm.propTypes, {
    className: _propTypes2.default.string,
    authClient: _propTypes2.default.func,
    classes: _propTypes2.default.object,
    input: _propTypes2.default.object,
    meta: _propTypes2.default.object,
    previousRoute: _propTypes2.default.string,
    translate: _propTypes2.default.func.isRequired,
    userLogin: _propTypes2.default.func.isRequired
});

Login.defaultProps = {
    theme: _defaultTheme2.default
};

var mapStateToProps = function mapStateToProps(state) {
    return { isLoading: state.admin.loading > 0 };
};

var enhance = (0, _compose2.default)(_translate2.default, (0, _reduxForm.reduxForm)({
    form: 'signIn',
    validate: function validate(values, props) {
        var errors = {};
        var translate = props.translate;

        if (!values.username) errors.username = translate('ra.validation.required');
        if (!values.password) errors.password = translate('ra.validation.required');
        return errors;
    }
}), (0, _reactRedux.connect)(mapStateToProps, { userLogin: _authActions.userLogin }), (0, _styles.withStyles)(styles));

exports.default = enhance(Login);
module.exports = exports['default'];