'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Refresh = require('material-ui-icons/Refresh');

var _Refresh2 = _interopRequireDefault(_Refresh);

var _styles = require('material-ui/styles');

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

var _uiActions = require('../../actions/uiActions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    iconPaddingStyle: {
        paddingRight: '0.5em'
    }
};

var sanitizeRestProps = function sanitizeRestProps(_ref) {
    var className = _ref.className,
        classes = _ref.classes,
        label = _ref.label,
        translate = _ref.translate,
        refreshView = _ref.refreshView,
        locale = _ref.locale,
        rest = (0, _objectWithoutProperties3.default)(_ref, ['className', 'classes', 'label', 'translate', 'refreshView', 'locale']);
    return rest;
};

var RefreshButton = function (_Component) {
    (0, _inherits3.default)(RefreshButton, _Component);

    function RefreshButton() {
        var _ref2;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, RefreshButton);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = RefreshButton.__proto__ || Object.getPrototypeOf(RefreshButton)).call.apply(_ref2, [this].concat(args))), _this), _this.handleClick = function (event) {
            event.preventDefault();
            _this.props.refreshView();
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(RefreshButton, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                className = _props.className,
                _props$classes = _props.classes,
                classes = _props$classes === undefined ? {} : _props$classes,
                label = _props.label,
                translate = _props.translate,
                refreshView = _props.refreshView,
                rest = (0, _objectWithoutProperties3.default)(_props, ['className', 'classes', 'label', 'translate', 'refreshView']);


            return _react2.default.createElement(
                _Button2.default,
                (0, _extends3.default)({
                    className: className,
                    color: 'primary',
                    onClick: this.handleClick
                }, sanitizeRestProps(rest)),
                _react2.default.createElement(_Refresh2.default, { className: classes.iconPaddingStyle }),
                label && translate(label)
            );
        }
    }]);
    return RefreshButton;
}(_react.Component);

RefreshButton.propTypes = {
    className: _propTypes2.default.string,
    classes: _propTypes2.default.object,
    label: _propTypes2.default.string,
    translate: _propTypes2.default.func.isRequired,
    refreshView: _propTypes2.default.func.isRequired
};
RefreshButton.defaultProps = {
    label: 'ra.action.refresh'
};


var enhance = (0, _compose2.default)(_translate2.default, (0, _reactRedux.connect)(null, { refreshView: _uiActions.refreshView }), (0, _styles.withStyles)(styles));

exports.default = enhance(RefreshButton);
module.exports = exports['default'];