'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Delete = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _inflection = require('inflection');

var _inflection2 = _interopRequireDefault(_inflection);

var _Card = require('material-ui/Card');

var _Card2 = _interopRequireDefault(_Card);

var _Toolbar = require('material-ui/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _styles = require('material-ui/styles');

var _CheckCircle = require('material-ui-icons/CheckCircle');

var _CheckCircle2 = _interopRequireDefault(_CheckCircle);

var _ErrorOutline = require('material-ui-icons/ErrorOutline');

var _ErrorOutline2 = _interopRequireDefault(_ErrorOutline);

var _Header = require('../layout/Header');

var _Header2 = _interopRequireDefault(_Header);

var _Title = require('../layout/Title');

var _Title2 = _interopRequireDefault(_Title);

var _dataActions = require('../../actions/dataActions');

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

var _DeleteActions = require('./DeleteActions');

var _DeleteActions2 = _interopRequireDefault(_DeleteActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
    return {
        button: {
            margin: theme.spacing.unit * 2
        },
        iconPaddingStyle: {
            paddingRight: '0.5em'
        }
    };
};

var sanitizeRestProps = function sanitizeRestProps(_ref) {
    var actions = _ref.actions,
        className = _ref.className,
        classes = _ref.classes,
        crudGetOne = _ref.crudGetOne,
        crudDelete = _ref.crudDelete,
        title = _ref.title,
        id = _ref.id,
        data = _ref.data,
        isLoading = _ref.isLoading,
        hasCreate = _ref.hasCreate,
        hasDelete = _ref.hasDelete,
        hasEdit = _ref.hasEdit,
        hasShow = _ref.hasShow,
        hasList = _ref.hasList,
        resource = _ref.resource,
        translate = _ref.translate,
        match = _ref.match,
        location = _ref.location,
        history = _ref.history,
        options = _ref.options,
        locale = _ref.locale,
        permissions = _ref.permissions,
        rest = (0, _objectWithoutProperties3.default)(_ref, ['actions', 'className', 'classes', 'crudGetOne', 'crudDelete', 'title', 'id', 'data', 'isLoading', 'hasCreate', 'hasDelete', 'hasEdit', 'hasShow', 'hasList', 'resource', 'translate', 'match', 'location', 'history', 'options', 'locale', 'permissions']);
    return rest;
};

/**
 * Page component for the Delete view
 * 
 * Can be used either directly inside a `<Resource>`, or to define
 * a custom Delete view.
 *
 * Here are all the props accepted by the `<Delete>`component:
 *
 * - title
 * - actions
 * 
 * Both expect an element for value.
 * 
 * @example
 *     import { Admin, Resource, Delete } from 'react-admin';
 *     import { PostList } from '../posts';
 *
 *     const App = () => (
 *         <Admin dataProvider={...}>
 *             <Resource name="posts" list={PostList} remove={Delete} />
 *         </Admin>
 *     );
 *
 * @example
 *     import PostDeleteActions from './DeleteActions';
 *     const PostDeleteTitle = ({ record }) => (
 *         <span>
 *             {record ? `Delete post ${record.title}` : ''}
 *         </span>
 *     ));
 *     const PostDelete = (props) =>
 *         <Delete
 *             title={<PostDeleteTitle />}
 *             actions={<PostDeleteActions />}
 *         />;
 *
 *     const App = () => (
 *         <Admin dataProvider={...}>
 *             <Resource name="posts" list={PostList} remove={PostDelete} />
 *         </Admin>
 *     );
 */

var Delete = exports.Delete = function (_Component) {
    (0, _inherits3.default)(Delete, _Component);

    function Delete(props) {
        (0, _classCallCheck3.default)(this, Delete);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Delete.__proto__ || Object.getPrototypeOf(Delete)).call(this, props));

        _this.handleSubmit = _this.handleSubmit.bind(_this);
        _this.goBack = _this.goBack.bind(_this);
        return _this;
    }

    (0, _createClass3.default)(Delete, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.crudGetOne(this.props.resource, this.props.id, this.getBasePath());
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.id !== nextProps.id) {
                this.props.crudGetOne(nextProps.resource, nextProps.id, this.getBasePath());
            }
        }
    }, {
        key: 'getBasePath',
        value: function getBasePath() {
            var location = this.props.location;

            return location.pathname.split('/').slice(0, -2).join('/');
        }
    }, {
        key: 'defaultRedirectRoute',
        value: function defaultRedirectRoute() {
            return 'list';
        }
    }, {
        key: 'handleSubmit',
        value: function handleSubmit(event) {
            event.preventDefault();
            this.props.crudDelete(this.props.resource, this.props.id, this.props.data, this.getBasePath(), this.props.redirect ? this.props.redirect : this.defaultRedirectRoute());
        }
    }, {
        key: 'goBack',
        value: function goBack() {
            this.props.history.goBack();
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                _props$actions = _props.actions,
                actions = _props$actions === undefined ? _react2.default.createElement(_DeleteActions2.default, null) : _props$actions,
                className = _props.className,
                _props$classes = _props.classes,
                classes = _props$classes === undefined ? {} : _props$classes,
                title = _props.title,
                id = _props.id,
                data = _props.data,
                isLoading = _props.isLoading,
                hasEdit = _props.hasEdit,
                hasShow = _props.hasShow,
                hasList = _props.hasList,
                resource = _props.resource,
                translate = _props.translate,
                props = (0, _objectWithoutProperties3.default)(_props, ['actions', 'className', 'classes', 'title', 'id', 'data', 'isLoading', 'hasEdit', 'hasShow', 'hasList', 'resource', 'translate']);

            var basePath = this.getBasePath();
            var rest = sanitizeRestProps(props);

            var resourceName = translate('resources.' + resource + '.name', {
                smart_count: 1,
                _: _inflection2.default.humanize(_inflection2.default.singularize(resource))
            });
            var defaultTitle = translate('ra.page.delete', {
                name: '' + resourceName,
                id: id,
                data: data
            });
            var titleElement = data ? _react2.default.createElement(_Title2.default, { title: title, record: data, defaultTitle: defaultTitle }) : '';

            return _react2.default.createElement(
                'div',
                (0, _extends3.default)({ className: className }, rest),
                _react2.default.createElement(
                    _Card2.default,
                    { style: { opacity: isLoading ? 0.8 : 1 } },
                    _react2.default.createElement(_Header2.default, {
                        title: titleElement,
                        actions: actions,
                        actionProps: {
                            basePath: basePath,
                            data: data,
                            hasEdit: hasEdit,
                            hasList: hasList,
                            hasShow: hasShow
                        }
                    }),
                    _react2.default.createElement(
                        'form',
                        { onSubmit: this.handleSubmit },
                        _react2.default.createElement(
                            _Card.CardContent,
                            null,
                            _react2.default.createElement(
                                _Typography2.default,
                                null,
                                translate('ra.message.are_you_sure')
                            )
                        ),
                        _react2.default.createElement(
                            _Toolbar2.default,
                            { disableGutters: true },
                            _react2.default.createElement(
                                _Button2.default,
                                {
                                    raised: true,
                                    type: 'submit',
                                    color: 'primary',
                                    className: classes.button
                                },
                                _react2.default.createElement(_CheckCircle2.default, {
                                    className: classes.iconPaddingStyle
                                }),
                                translate('ra.action.delete')
                            ),
                            '\xA0',
                            _react2.default.createElement(
                                _Button2.default,
                                {
                                    raised: true,
                                    onClick: this.goBack,
                                    className: classes.button
                                },
                                _react2.default.createElement(_ErrorOutline2.default, {
                                    className: classes.iconPaddingStyle
                                }),
                                translate('ra.action.cancel')
                            )
                        )
                    )
                )
            );
        }
    }]);
    return Delete;
}(_react.Component);

Delete.propTypes = {
    actions: _propTypes2.default.element,
    className: _propTypes2.default.string,
    classes: _propTypes2.default.object,
    crudDelete: _propTypes2.default.func.isRequired,
    crudGetOne: _propTypes2.default.func.isRequired,
    data: _propTypes2.default.object,
    hasCreate: _propTypes2.default.bool,
    hasDelete: _propTypes2.default.bool,
    hasEdit: _propTypes2.default.bool,
    hasShow: _propTypes2.default.bool,
    hasList: _propTypes2.default.bool,
    history: _propTypes2.default.object.isRequired,
    id: _propTypes2.default.string.isRequired,
    isLoading: _propTypes2.default.bool.isRequired,
    location: _propTypes2.default.object.isRequired,
    match: _propTypes2.default.object.isRequired,
    redirect: _propTypes2.default.string,
    resource: _propTypes2.default.string.isRequired,
    title: _propTypes2.default.any,
    translate: _propTypes2.default.func.isRequired
};

function mapStateToProps(state, props) {
    return {
        id: decodeURIComponent(props.match.params.id),
        data: state.admin.resources[props.resource].data[decodeURIComponent(props.match.params.id)],
        isLoading: state.admin.loading > 0
    };
}

var enhance = (0, _compose2.default)((0, _reactRedux.connect)(mapStateToProps, { crudGetOne: _dataActions.crudGetOne, crudDelete: _dataActions.crudDelete }), (0, _styles.withStyles)(styles), _translate2.default);

exports.default = enhance(Delete);