'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DatagridHeaderCell = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _shouldUpdate = require('recompose/shouldUpdate');

var _shouldUpdate2 = _interopRequireDefault(_shouldUpdate);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Table = require('material-ui/Table');

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _styles = require('material-ui/styles');

var _Sort = require('material-ui-icons/Sort');

var _Sort2 = _interopRequireDefault(_Sort);

var _FieldTitle = require('../../util/FieldTitle');

var _FieldTitle2 = _interopRequireDefault(_FieldTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    cellRightAligned: { textAlign: 'right' },
    sortButton: {
        minWidth: 40
    },
    sortIcon: {
        transition: 'transform .25s cubic-bezier(0.0, 0, 0.2, 1)',
        marginLeft: '0.5em'
    },
    sortIconReversed: {
        transform: 'rotate(180deg)'
    },
    nonSortableLabel: {
        position: 'relative',
        paddingLeft: 16,
        paddingRight: 16,
        verticalAlign: 'middle',
        letterSpacing: 0,
        textTransform: 'uppercase',
        fontWeight: 500,
        fontSize: 14
    }
};

var DatagridHeaderCell = function DatagridHeaderCell(_ref) {
    var _ref$classes = _ref.classes,
        classes = _ref$classes === undefined ? {} : _ref$classes,
        className = _ref.className,
        field = _ref.field,
        currentSort = _ref.currentSort,
        updateSort = _ref.updateSort,
        resource = _ref.resource,
        isSorting = _ref.isSorting,
        rest = (0, _objectWithoutProperties3.default)(_ref, ['classes', 'className', 'field', 'currentSort', 'updateSort', 'resource', 'isSorting']);
    return _react2.default.createElement(
        _Table.TableCell,
        (0, _extends3.default)({
            className: (0, _classnames3.default)((0, _defineProperty3.default)({}, classes.cellRightAligned, field.props.textAlign === 'right'), className, field.props.headerClassName)
        }, rest),
        field.props.sortable !== false && field.props.source ? _react2.default.createElement(
            _Button2.default,
            {
                onClick: updateSort,
                'data-sort': field.props.source,
                className: classes.sortButton
            },
            _react2.default.createElement(_FieldTitle2.default, {
                label: field.props.label,
                source: field.props.source,
                resource: resource
            }),
            field.props.source === currentSort.field && _react2.default.createElement(_Sort2.default, {
                className: (0, _classnames3.default)(classes.sortIcon, currentSort.order === 'ASC' ? classes.sortIconReversed : '')
            })
        ) : _react2.default.createElement(
            'span',
            { className: classes.nonSortableLabel },
            _react2.default.createElement(_FieldTitle2.default, {
                label: field.props.label,
                source: field.props.source,
                resource: resource
            })
        )
    );
};

exports.DatagridHeaderCell = DatagridHeaderCell;
DatagridHeaderCell.propTypes = {
    classes: _propTypes2.default.object,
    className: _propTypes2.default.string,
    field: _propTypes2.default.element,
    currentSort: _propTypes2.default.shape({
        sort: _propTypes2.default.string,
        order: _propTypes2.default.string
    }),
    isSorting: _propTypes2.default.bool,
    sortable: _propTypes2.default.bool,
    resource: _propTypes2.default.string,
    updateSort: _propTypes2.default.func.isRequired
};

var enhance = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
    return props.isSorting !== nextProps.isSorting || nextProps.isSorting && props.currentSort.order !== nextProps.currentSort.order;
}), (0, _styles.withStyles)(styles));

exports.default = enhance(DatagridHeaderCell);