'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Avatar = require('material-ui/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _List = require('material-ui/List');

var _List2 = _interopRequireDefault(_List);

var _styles = require('material-ui/styles');

var _reactRouterDom = require('react-router-dom');

var _linkToRecord = require('../../util/linkToRecord');

var _linkToRecord2 = _interopRequireDefault(_linkToRecord);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    link: {
        textDecoration: 'none',
        color: 'inherit'
    },
    tertiary: { float: 'right', opacity: 0.541176 }
};

var LinkOrNot = (0, _styles.withStyles)(styles)(function (_ref) {
    var classes = _ref.classes,
        linkType = _ref.linkType,
        basePath = _ref.basePath,
        id = _ref.id,
        children = _ref.children;
    return linkType === 'edit' || linkType === true ? _react2.default.createElement(
        _reactRouterDom.Link,
        { to: (0, _linkToRecord2.default)(basePath, id), className: classes.link },
        children
    ) : linkType === 'show' ? _react2.default.createElement(
        _reactRouterDom.Link,
        {
            to: (0, _linkToRecord2.default)(basePath, id) + '/show',
            className: classes.link
        },
        children
    ) : _react2.default.createElement(
        'span',
        null,
        children
    );
});

var SimpleList = function SimpleList(_ref2) {
    var _ref2$classes = _ref2.classes,
        classes = _ref2$classes === undefined ? {} : _ref2$classes,
        className = _ref2.className,
        currentSort = _ref2.currentSort,
        isLoading = _ref2.isLoading,
        setSort = _ref2.setSort,
        ids = _ref2.ids,
        data = _ref2.data,
        basePath = _ref2.basePath,
        primaryText = _ref2.primaryText,
        secondaryText = _ref2.secondaryText,
        tertiaryText = _ref2.tertiaryText,
        leftAvatar = _ref2.leftAvatar,
        leftIcon = _ref2.leftIcon,
        rightAvatar = _ref2.rightAvatar,
        rightIcon = _ref2.rightIcon,
        linkType = _ref2.linkType,
        rest = (0, _objectWithoutProperties3.default)(_ref2, ['classes', 'className', 'currentSort', 'isLoading', 'setSort', 'ids', 'data', 'basePath', 'primaryText', 'secondaryText', 'tertiaryText', 'leftAvatar', 'leftIcon', 'rightAvatar', 'rightIcon', 'linkType']);
    return _react2.default.createElement(
        _List2.default,
        (0, _extends3.default)({ className: className }, rest),
        ids.map(function (id) {
            return _react2.default.createElement(
                LinkOrNot,
                { linkType: linkType, basePath: basePath, id: id, key: id },
                _react2.default.createElement(
                    _List.ListItem,
                    { button: true },
                    leftIcon && _react2.default.createElement(
                        _List.ListItemIcon,
                        null,
                        leftIcon(data[id], id)
                    ),
                    leftAvatar && _react2.default.createElement(
                        _List.ListItemAvatar,
                        null,
                        _react2.default.createElement(
                            _Avatar2.default,
                            null,
                            leftAvatar(data[id], id)
                        )
                    ),
                    _react2.default.createElement(_List.ListItemText, {
                        primary: _react2.default.createElement(
                            'div',
                            null,
                            primaryText(data[id], id),
                            tertiaryText && _react2.default.createElement(
                                'span',
                                { className: classes.tertiary },
                                tertiaryText(data[id], id)
                            )
                        ),
                        secondary: secondaryText && secondaryText(data[id], id)
                    }),
                    (rightAvatar || rightIcon) && _react2.default.createElement(
                        _List.ListItemSecondaryAction,
                        null,
                        rightAvatar && _react2.default.createElement(
                            _Avatar2.default,
                            null,
                            rightAvatar(data[id], id)
                        ),
                        rightIcon && _react2.default.createElement(
                            _List.ListItemIcon,
                            null,
                            rightIcon(data[id], id)
                        )
                    )
                )
            );
        })
    );
};

SimpleList.propTypes = {
    classes: _propTypes2.default.object,
    className: _propTypes2.default.string,
    ids: _propTypes2.default.array,
    data: _propTypes2.default.object,
    basePath: _propTypes2.default.string,
    primaryText: _propTypes2.default.func,
    secondaryText: _propTypes2.default.func,
    tertiaryText: _propTypes2.default.func,
    leftAvatar: _propTypes2.default.func,
    leftIcon: _propTypes2.default.func,
    rightAvatar: _propTypes2.default.func,
    rightIcon: _propTypes2.default.func,
    linkType: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]).isRequired
};

SimpleList.defaultProps = {
    linkType: 'edit'
};

exports.default = (0, _styles.withStyles)(styles)(SimpleList);
module.exports = exports['default'];